using System;
using System.Data;
using Microsoft.SqlServer.Server;
using System.Data.SqlTypes;
using System.IO;
using System.Text;


//use clr serialization to serialize the intermediate result
//optimizer property
//optimizer property
//optimizer property
//maximum size in bytes of persisted value
[Serializable]
[SqlUserDefinedAggregate(
    Format.UserDefined, //use clr serialization to serialize the intermediate result 
    IsInvariantToNulls = true, //optimizer property 
    IsInvariantToDuplicates = false, //optimizer property 
    IsInvariantToOrder = false, //optimizer property 
    MaxByteSize = 8000) //maximum size in bytes of persisted value 
]
public struct First : IBinarySerialize
{

    private string allValues;

    public void Init()
    {
        allValues = string.Empty;
    }

    private void incrementAndAdd(SqlInt32 value)
    {

        allValues += (value.Value.ToString() + ",");
    }

    public void Accumulate(SqlInt32 Value)
    {

        incrementAndAdd(Value);
    }

    public void Merge(First Group)
    {

    }

    public SqlInt32 Terminate()
    {
        // Put your code here 
        return new SqlInt32(int.Parse(allValues.Split(',')[0]));
    }

    // This is a place-holder member field 
    //private SqlInt32 var1;


    public void Read(System.IO.BinaryReader r)
    {

        allValues = r.ReadString();
    }

    public void Write(System.IO.BinaryWriter w)
    {

        w.Write(this.allValues);
    }
}
