USE Lib
GO

---------------------------------------------------------------------------
-- BEGIN MAINTENANCE WRAPPER
----------------------------
IF EXISTS (SELECT * FROM sysobjects WHERE type = 'FN' AND name = 'fn_month_first_day') BEGIN
	DROP  FUNCTION  tsql.fn_month_first_day
	PRINT '<<< DROP FUNCTION tsql.fn_month_first_day - Completed with SUCCESS >>>'
END
GO


/*================================================================================================
Name:			tsql.fn_month_last_day
Type:			User defined function 
Owner:			
Project:			
Description:	Returns the first day of the month
Parameters:		@date = date to get first day for
Dependens on:  	none
Usage:			SELECT [tsql].[fn_month_first_day] (GETDATE())
--------------------------------------------------------------------------------------------------
Version:		20091202
SrcCtrlApp:		
SrcCtrlPath:	
--------------------------------------------------------------------------------------------------
History:		12/02/2009 - Adrian E Dudau - Function created
================================================================================================*/


CREATE FUNCTION tsql.fn_month_first_day (@date DATETIME)
RETURNS DATETIME
AS

BEGIN
	RETURN DATEADD(MONTH, DATEDIFF(MONTH,0,@date),0)
END

GO

---------------------------------------------------------------------------
-- BEGIN MAINTENANCE WRAPPER
-- Verify completion
----------------------------
IF EXISTS(SELECT * FROM sysobjects WHERE type = 'FN' AND name = 'fn_month_first_day') BEGIN 
	PRINT '<<< CREATE FUNCTION tsql.fn_month_first_day - Completed with SUCCESS >>>'
END

ELSE BEGIN 
	PRINT '<<< CREATE FUNCTION tsql.fn_month_first_day - Completed with ERROR >>>'
END


GO
----------------------------
-- END MAINTENANCE WRAPPER
---------------------------------------------------------------------------

-- GRANT SELECT TO PUBLIC will be used at Db level



