USE Lib
GO

---------------------------------------------------------------------------
-- BEGIN MAINTENANCE WRAPPER
----------------------------
IF EXISTS (SELECT * FROM sysobjects WHERE type = 'FN' AND name = 'fn_year_last_day') BEGIN
	DROP  FUNCTION  tsql.fn_year_last_day
	PRINT '<<< DROP FUNCTION tsql.fn_year_last_day - Completed with SUCCESS >>>'
END
GO


/*================================================================================================
Name:			tsql.fn_year_last_day
Type:			User defined function 
Owner:			
Description:	Returns the last day of the month
Parameters:		@date = date to get the last day for
Dependens on:  	none
Usage:			SELECT [Lib].[tsql].[fn_year_last_day] (GETDATE())
--------------------------------------------------------------------------------------------------
Project:		http://sqllib.codeplex.com/
Help:			http://sqllib.codeplex.com/wikipage?title=fn_year_last_day&referringTitle=Documentation		
Version:		20121018
SrcCtrlApp:		SVN
SrcCtrlPath:	http://sqllib.codeplex.com/SourceControl/list/changesets
--------------------------------------------------------------------------------------------------
History:		10/18/2012 - Adrian E Dudau - Function created
================================================================================================*/


CREATE FUNCTION tsql.fn_year_last_day (@date DATETIME)
RETURNS DATETIME
AS

BEGIN
	RETURN DATEADD(DAY,-1,DATEADD(YEAR, DATEDIFF(YEAR,0,@date) + 1,0)) 
END

GO

---------------------------------------------------------------------------
-- BEGIN MAINTENANCE WRAPPER
-- Verify completion
----------------------------
IF EXISTS(SELECT * FROM sysobjects WHERE type = 'FN' AND name = 'fn_year_last_day') BEGIN 
	PRINT '<<< CREATE FUNCTION tsql.fn_year_last_day - Completed with SUCCESS >>>'
END

ELSE BEGIN 
	PRINT '<<< CREATE FUNCTION tsql.fn_year_last_day - Completed with ERROR >>>'
END


GO
----------------------------
-- END MAINTENANCE WRAPPER
---------------------------------------------------------------------------

-- GRANT SELECT TO PUBLIC will be used at Db level



