USE SQLLib;
GO

SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO
IF OBJECT_ID (N'tsql.fn_gregorian2julian') IS NOT NULL
BEGIN
	DROP FUNCTION tsql.fn_gregorian2julian;
	PRINT 'Previous version of fn_gregorian2julian dropped!';
END
GO

CREATE FUNCTION [tsql].[fn_gregorian2julian] ( @gregorian DATETIME ) RETURNS NUMERIC (5, 0)
  AS
	/*================================================================================================
	Name:			tsql.[fn_gregorian2julian]
	Type:			User defined function 
	Owner:					
	Description:	convert a gregorian date to julian date
	Parameters:		@gregorian = the date to convert
	Dependens on:  	[fn_gregorian2julian]
	Usage:			
					SELECT [tsql].[fn_gregorian2julian] ('2012-09-26')
	--------------------------------------------------------------------------------------------------
	Project:		http://sqllib.codeplex.com/
	Help:			
	Version:		201209026
	SrcCtrlApp:		SVN
	SrcCtrlPath:	http://sqllib.codeplex.com/SourceControl/list/changesets
	--------------------------------------------------------------------------------------------------
	History:		09/26/2012 - H.Winther - Function created
	================================================================================================*/  
	BEGIN
	  RETURN DATEDIFF (d, '1957-01-01', @gregorian);
	END
GO


